trylink: make messages less confusing
[oweals/busybox.git] / scripts / trylink
1 #!/bin/sh
2
3 debug=false
4
5 # Linker flags used:
6 #
7 # Informational:
8 # --warn-common
9 # -Map $EXE.map
10 # --verbose
11 #
12 # Optimizations:
13 # --sort-common                 reduces padding
14 # --sort-section alignment      reduces padding
15 # --gc-sections                 throws out unused sections,
16 #                               does not work for shared libs
17 # -On                           Not used, maybe useful?
18 #
19 # List of files to link:
20 # $l_list                       == --start-group -llib1 -llib2 --end-group
21 # --start-group $O_FILES $A_FILES --end-group
22 #
23 # Shared library link:
24 # -shared                       self-explanatory
25 # -fPIC                         position-independent code
26 # --enable-new-dtags            ?
27 # -z,combreloc                  ?
28 # -soname="libbusybox.so.$BB_VER"
29 # --undefined=lbb_main          Seed name to start pulling from
30 #                               (otherwise we'll need --whole-archive)
31 # -static                       Not used, but may be useful! manpage:
32 #                               "... This option can be used with -shared.
33 #                               Doing so means that a shared library
34 #                               is being created but that all of the library's
35 #                               external references must be resolved by pulling
36 #                               in entries from static libraries."
37
38
39 try() {
40     printf "%s\n" "Output of:" >$EXE.out
41     printf "%s\n" "$*" >>$EXE.out
42     printf "%s\n" "==========" >>$EXE.out
43     $debug && echo "Trying: $*"
44     "$@" >>$EXE.out 2>&1
45     exitcode=$?
46     return $exitcode
47 }
48
49 check_cc() {
50     local tempname="/tmp/temp.$$.$RANDOM"
51     # Can use "-o /dev/null", but older gcc tend to *unlink it* on failure! :(
52     # "-xc": C language. "/dev/null" is an empty source file.
53     if $CC $1 -shared -xc /dev/null -o "$tempname".o >/dev/null 2>&1; then
54         echo "$1";
55     else
56         echo "$2";
57     fi
58     rm "$tempname".o 2>/dev/null
59 }
60
61 check_libc_is_glibc() {
62     local tempname="/tmp/temp.$$.$RANDOM"
63     echo "\
64         #include <stdlib.h>
65         /* Apparently uclibc defines __GLIBC__ (compat trick?). Oh well. */
66         #if defined(__GLIBC__) && !defined(__UCLIBC__)
67         syntax error here
68         #endif
69         " >"$tempname".c
70     if $CC "$tempname".c -c -o "$tempname".o >/dev/null 2>&1; then
71         echo "$2";
72     else
73         echo "$1";
74     fi
75     rm "$tempname".c "$tempname".o 2>/dev/null
76 }
77
78 EXE="$1"
79 CC="$2"
80 CFLAGS="$3"
81 LDFLAGS="$4"
82 O_FILES="$5"
83 A_FILES="$6"
84 LDLIBS="$7"
85
86 # The --sort-section option is not supported by older versions of ld
87 SORT_SECTION=`check_cc "-Wl,--sort-section,alignment" ""`
88
89 # Static linking against glibc produces buggy executables
90 # (glibc does not cope well with ld --gc-sections).
91 # See sources.redhat.com/bugzilla/show_bug.cgi?id=3400
92 # Note that glibc is unsuitable for static linking anyway.
93 # We are removing -Wl,--gc-sections from link command line.
94 GC_SECTIONS=`(
95 . ./.config
96 if test x"$CONFIG_STATIC" = x"y"; then
97     check_libc_is_glibc "" "-Wl,--gc-sections"
98 else
99     echo "-Wl,--gc-sections"
100 fi
101 )`
102
103 # Sanitize lib list (dups, extra spaces etc)
104 LDLIBS=`echo "$LDLIBS" | xargs -n1 | sort | uniq | xargs`
105
106 # First link with all libs. If it fails, bail out
107 echo "Trying libraries: $LDLIBS"
108 # "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
109 l_list=`echo "$LDLIBS" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
110 test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
111 try $CC $CFLAGS $LDFLAGS \
112         -o $EXE \
113         -Wl,--sort-common \
114         $SORT_SECTION \
115         $GC_SECTIONS \
116         -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
117         $l_list \
118 || {
119     echo "Failed: $l_list"
120     cat $EXE.out
121     exit 1
122 }
123
124 # Now try to remove each lib and build without it.
125 # Stop when no lib can be removed.
126 while test "$LDLIBS"; do
127     $debug && echo "Trying libraries: $LDLIBS"
128     all_needed=true
129     last_needed=false
130     for one in $LDLIBS; do
131         without_one=`echo " $LDLIBS " | sed "s/ $one / /g" | xargs`
132         # "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
133         l_list=`echo "$without_one" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
134         test x"$l_list" != x"" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
135         $debug && echo "Trying -l options: '$l_list'"
136         try $CC $CFLAGS $LDFLAGS \
137                 -o $EXE \
138                 -Wl,--sort-common \
139                 $SORT_SECTION \
140                 $GC_SECTIONS \
141                 -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
142                 $l_list
143         if test $? = 0; then
144             echo " Library $one is not needed, excluding it"
145             LDLIBS="$without_one"
146             all_needed=false
147             last_needed=false
148         else
149             echo " Library $one is needed, can't exclude it (yet)"
150             last_needed=true
151         fi
152     done
153     # All libs were needed, can't remove any
154     $all_needed && break
155     # Optimization: was the last tried lib needed?
156     if $last_needed; then
157         # Was it the only one lib left? Don't test again then.
158         { echo "$LDLIBS" | grep -q ' '; } || break
159     fi
160 done
161
162 # Make the binary with final, minimal list of libs
163 echo "Final link with: ${LDLIBS:-<none>}"
164 l_list=`echo "$LDLIBS" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
165 test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
166 # --verbose gives us gobs of info to stdout (e.g. linker script used)
167 if ! test -f busybox_ldscript; then
168     try $CC $CFLAGS $LDFLAGS \
169             -o $EXE \
170             -Wl,--sort-common \
171             $SORT_SECTION \
172             $GC_SECTIONS \
173             -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
174             $l_list \
175             -Wl,--warn-common \
176             -Wl,-Map,$EXE.map \
177             -Wl,--verbose \
178     || {
179         cat $EXE.out
180         exit 1
181     }
182 else
183     echo "Custom linker script 'busybox_ldscript' found, using it"
184     # Add SORT_BY_ALIGNMENT to linker script (found in $EXE.out):
185     #  .rodata         : { *(.rodata SORT_BY_ALIGNMENT(.rodata.*) .gnu.linkonce.r.*) }
186     #  *(.data SORT_BY_ALIGNMENT(.data.*) .gnu.linkonce.d.*)
187     #  *(.bss SORT_BY_ALIGNMENT(.bss.*) .gnu.linkonce.b.*)
188     # This will eliminate most of the padding (~3kb).
189     # Hmm, "ld --sort-section alignment" should do it too.
190     try $CC $CFLAGS $LDFLAGS \
191             -o $EXE \
192             -Wl,--sort-common \
193             $SORT_SECTION \
194             $GC_SECTIONS \
195             -Wl,-T,busybox_ldscript \
196             -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
197             $l_list \
198             -Wl,--warn-common \
199             -Wl,-Map,$EXE.map \
200             -Wl,--verbose \
201     || {
202         cat $EXE.out
203         exit 1
204     }
205 fi
206
207 . ./.config
208
209 sharedlib_dir="0_lib"
210
211 if test "$CONFIG_BUILD_LIBBUSYBOX" = y; then
212     mkdir "$sharedlib_dir" 2>/dev/null
213     test -d "$sharedlib_dir" || {
214         echo "Cannot make directory $sharedlib_dir"
215         exit 1
216     }
217     ln -s "libbusybox.so.$BB_VER" "$sharedlib_dir"/libbusybox.so 2>/dev/null
218
219     EXE="$sharedlib_dir/libbusybox.so.${BB_VER}_unstripped"
220     try $CC $CFLAGS $LDFLAGS \
221             -o $EXE \
222             -shared -fPIC \
223             -Wl,--enable-new-dtags \
224             -Wl,-z,combreloc \
225             -Wl,-soname="libbusybox.so.$BB_VER" \
226             -Wl,--undefined=lbb_main \
227             -Wl,--sort-common \
228             $SORT_SECTION \
229             -Wl,--start-group $A_FILES -Wl,--end-group \
230             $l_list \
231             -Wl,--warn-common \
232             -Wl,-Map,$EXE.map \
233             -Wl,--verbose \
234     || {
235         echo "Linking $EXE failed"
236         cat $EXE.out
237         exit 1
238     }
239     $STRIP -s --remove-section=.note --remove-section=.comment $EXE -o "$sharedlib_dir/libbusybox.so.$BB_VER"
240     chmod a+x "$sharedlib_dir/libbusybox.so.$BB_VER"
241     echo "libbusybox: $sharedlib_dir/libbusybox.so.$BB_VER"
242 fi
243
244 if test "$CONFIG_FEATURE_SHARED_BUSYBOX" = y; then
245     EXE="$sharedlib_dir/busybox_unstripped"
246     try $CC $CFLAGS $LDFLAGS \
247             -o $EXE \
248             -Wl,--sort-common \
249             $SORT_SECTION \
250             $GC_SECTIONS \
251             -Wl,--start-group $O_FILES -Wl,--end-group \
252             -L"$sharedlib_dir" -lbusybox \
253             -Wl,--warn-common \
254             -Wl,-Map,$EXE.map \
255             -Wl,--verbose \
256     || {
257         echo "Linking $EXE failed"
258         cat $EXE.out
259         exit 1
260     }
261     $STRIP -s --remove-section=.note --remove-section=.comment $EXE -o "$sharedlib_dir/busybox"
262     echo "busybox linked against libbusybox: $sharedlib_dir/busybox"
263 fi
264
265 if test "$CONFIG_FEATURE_INDIVIDUAL" = y; then
266     echo "Linking individual applets against libbusybox (see $sharedlib_dir/*)"
267     gcc -DNAME_MAIN_CNAME -E -include include/autoconf.h include/applets.h \
268     | grep -v "^#" \
269     | grep -v "^$" \
270     > applet_lst.tmp
271     while read name main junk; do
272
273         echo "\
274 void lbb_prepare(const char *applet, char **argv);
275 int $main(int argc, char **argv);
276
277 int main(int argc, char **argv)
278 {
279         lbb_prepare(\"$name\", argv);
280         return $main(argc, argv);
281 }
282 " >"$sharedlib_dir/applet.c"
283
284         EXE="$sharedlib_dir/$name"
285         try $CC $CFLAGS $LDFLAGS "$sharedlib_dir/applet.c" \
286                 -o $EXE \
287                 -Wl,--sort-common \
288                 $SORT_SECTION \
289                 $GC_SECTIONS \
290                 -L"$sharedlib_dir" -lbusybox \
291                 -Wl,--warn-common \
292         || {
293             echo "Linking $EXE failed"
294             cat $EXE.out
295             exit 1
296         }
297         rm -- "$sharedlib_dir/applet.c" $EXE.out
298         $STRIP -s --remove-section=.note --remove-section=.comment $EXE
299
300     done <applet_lst.tmp
301 fi
302
303 # libbusybox.so is needed only for -lbusybox at link time,
304 # it is not needed at runtime. Deleting to reduce confusion.
305 rm "$sharedlib_dir"/libbusybox.so 2>/dev/null
306 exit 0 # or else we may confuse make